# Purpose

This is to help debugging programs for the distributed-memory backend.
Adding print statements will change the program as side-effects must be
observed, so that is not a valid way of debugging. Instead the memory
must be inspected directly. This is a utility of doing so automatically
using gdb.

# Usage

This directory will be copied to your build directory by cmake.
Navigate there and put your program <name>.sac in the src directory.
You can compile this using

```make bin/name```

Then run your program on n cores using

```./debug.sh n name```

For each distributed variable x, the memory will be dumped in a x_s.bin file,
where x_s.bin is the memory at node s, with zeroes for non-local memory
(may be Linux specific behaviour, but that is assumed anyways with this
backend). Depending on the type, this can be converted using
```bin_to_double.sh``` and friends.
The left-hand side number is the address in bytes, the right-hand side is
the value.

# Note

You may need to change the endianness in bin_to_*.sh
This relies on clang-format and requires the programs nuke_empty, nuke_semi
from the parent directory to be in your path.

# TODO

Perhaps a fully-fledged pretty printer that removes redundant scoping
and empty statements for the .i file is in order. I don't want to implement
this myself, but cannot find a program for this on the internet.
