#ifndef _SAC_PROFILE_H_
#define _SAC_PROFILE_H_

/******************************************************************************
 *
 * Functionality for timing compiler phases, subphases, and cycles.
 *
 * A .treport file is created, which can be imported to https://ui.perfetto.dev/
 * for a visualisation of the compiler phases.
 *
 ******************************************************************************/

#include "config.h"

#ifndef HAVE_GETTIME

#define TIMEbegin(x)
#define TIMEend(x)
#define TIMEtimeReport(x, info)

#else

#include <time.h>
#include <sys/times.h>

typedef struct timeinfo_t {
    compiler_phase_t phase;
    struct timespec start;
    struct timespec end;
    struct timeinfo_t *next; /* Used to generate report */
} timeinfo_t;

void TIMEbegin (compiler_phase_t);
void TIMEend (compiler_phase_t);
node *TIMEtimeReport (node *, info *);

#endif /* HAVE_GETTIME */
#endif /* _SAC_PROFILE_H_ */
